Skip to main content

Greedy Algorithm - Question 1

 Leetcode 435 Non-overlapping Intervals

Given an array of intervals intervals where intervals[i] = [starti, endi], return the minimum number of intervals you need to remove to make the rest of the intervals non-overlapping.

Constraints:

1 <= intervals.length <= 10^5

intervals[i].length == 2

-5 * 10^4 <= starti < endi <= 5 * 10^4


Analysis:

This question is equivalent to a classic question: interval scheduling, which searches for the maximum number of un-overlapping intervals. Once this number is found, then it is straightforward to calculate the minimum number of intervals to be removed.

When all the intervals are sorted with the ending time, then we can always pick up the first interval as the first step. Why does this always give the optimal result?

Because this interval ends the earliest!

Just because it ends the earliest, choosing it cannot be worse than choosing other intervals. Thus we can greedily choose the first one.

After the first one is chosen, we can again pick up the first interval with a starting time after the ending time of the first interval picked, The argument of the correctness is similar to the first one.

Therefore, for each step, we can always greedily pick up the first valid interval (no overlapping with the previous interval). (Just because it ends the earliest for all the rest intervals).


See the code below:


class Solution {
public:
    int eraseOverlapIntervals(vector<vector<int>>& intervals) {
        int n = intervals.size(), ct = 0, front = -1e5;
        sort(intervals.begin(), intervals.end(), [](auto &a, auto &b) {
            // if(a[1] == b[1]) return a[0] < b[0];
            return a[1] < b[1];
        });
        for(int i=0; i<n; ++i) {
            if(intervals[i][0] < front) continue;
            ++ct;
            front = intervals[i][1];
        }
        return n - ct;
    }
};


Upper Layer

Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once...

Bit Manipulation - Example

  Leetcode 136 Single Number Given a non-empty array of integers nums, every element appears twice except for one. Find that single one. You must implement a solution with a linear runtime complexity and use only constant extra space. Constraints: 1 <= nums.length <= 3 * 10^4 -3 * 10^4 <= nums[i] <= 3 * 10^4 Each element in the array appears twice except for one element which appears only once. Analysis: If there is no space limitation, this question can be solved by counting easily. But counting requires additional space. Here we can use xor (^) operation based on some interesting observations:  A^A = 0, here A is any number A^0 = A, here A is any number Since all the number appears twice except one, then all the number appear even numbers will be cancelled out, and only the number appears one time is left, which is what we want. See the code below: class Solution { public: int singleNumber(vector<int>& nums) { int res = 0; for(auto ...

Rolling Hash

Rolling hash is one common trick used to increase efficiency of substring comparisons by compressing (or hashing) a string into a integer. After this step, we can compare two strings directly without comparing each chars. So the efficiency can be increased from O(N) to O(1). So how to implement the rolling hash? First we need to choose a base for the expansion and a modulo to mod. The basic formula is (suppose the window is n, and the rolling direction is from left to right), HashVal = (A1*p^(n-1) + A2*p^(n-2) + ... + An-1*p^1 + An*p^0)%mod where HashVal is the hash value, Ai is the ith element, p is the base, and mod is the modulo. To avoid collision as much as we can, p and modulo usually need to be large prime numbers. One corner case is that the base order in the above formula cannot be reversed. Or to be more clear, if the rolling direction is from left to right in an array, the first element should be in the highest order of the base, or times p^(n-1), and the last element times ...